﻿//////////////////////////////////////////////
// PbsMaterialInfo.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkGraphics
{
	class Texture ;
}

/// Includes ---------------------------------

// nkMaths
#include <NilkinsMaths/Algebra/Vector.h>

/// Class ------------------------------------

namespace nkAstraeus
{
	struct PbsMaterialInfo
	{
		// Structures
		nkMaths::Vector _lightDir = nkMaths::Vector(1.f, -1.f, 1.f) ;
		nkMaths::Vector _lightColor ;
		nkMaths::Vector _albedoColor ;
		nkMaths::Vector _envColor ;

		float _metalness = 0.5f ;
		float _roughness = 0.5f ;

		// Pointers
		nkGraphics::Texture* _albedoTex = nullptr ;
		nkGraphics::Texture* _envTex = nullptr ;
		nkGraphics::Texture* _irradianceTex = nullptr ;
		nkGraphics::Texture* _metalnessTex = nullptr ;
		nkGraphics::Texture* _roughnessTex = nullptr ;

		// Flags
		bool _envTexIsCubeByDefault = true ;
		bool _irradianceTexIsCubeByDefault = true ;

		// Loading witnesses for updates
		bool _usingAlbedoTex = false ;
		bool _usingEnvTex = false ;
		bool _usingIrradianceTex = false ;
		bool _usingMetalnessTex = false ;
		bool _usingRoughnessTex = false ;
	} ;
}