﻿//////////////////////////////////////////////
// ExportError.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkExport
#include "../Dll/DllDefines.h"

// Standards
#include <string>

/// Class ------------------------------------
	
namespace nkExport
{
	class DLL_EXPORT_EXPORT ExportError final
	{
		private :

			// Attributs
			// Description
			std::string _errorDesc ;
			std::string _errorInfo ;
			// Offsets pour retrouver 
			unsigned int _index ;

			// Si on a ete activee
			bool _activated ;
		
		public :
		
			// Constructeur, destructeur
			ExportError () ;
			ExportError (const char* errorDesc, const char* errorInfos, unsigned int index) ;
			~ExportError () ;

			// Setters
			void setErrorDesc (const char* desc) ;
			void setErrorInfo (const char* infos) ;
			void setIndex (unsigned int index) ;
			void setActivated (bool value) ;

			// Getters
			const char* getErrorDesc () const ;
			const char* getErrorInfo () const ;
			unsigned int getIndex () const ;
			bool isActivated () const ;
	} ;
}