﻿//////////////////////////////////////////////
// MeshLoadResult.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Foward decl ------------------------------

namespace nkGraphics
{
	class Mesh ;
}

/// Includes ---------------------------------

// nkGraphics
#include "../../Dll/DllDefines.h"

// Standards
#include <string>

/// Class ------------------------------------
	
namespace nkGraphics
{
	// Classe
	class DLL_GRAPHICS_EXPORT MeshLoadResult
	{
		private :
		
			// Attributs
			// Le résultat
			bool _success ;

			// Le mesh final
			Mesh* _mesh ;

			// Un message s'il faut
			std::string _message ;
			
		public :
		
			// Constructeur, destructeur
			MeshLoadResult () ;
			MeshLoadResult (const MeshLoadResult& other) ;
			MeshLoadResult (MeshLoadResult&& other) ;
			~MeshLoadResult () ;

			// Getters
			bool getSuccess () const ;
			Mesh* getMesh () const ;
			const char* getMessage () const ;

			// Setters
			void setSuccess (bool value) ;
			void setMesh (Mesh* value) ;
			void setMessage (const char* message) ;
	} ;
}