﻿//////////////////////////////////////////////
// Pass.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkGraphics
{
	class TargetOperations ;
}

/// Includes ---------------------------------

// nkGraphics
#include "PassType.h"

#include "../Dll/DllDefines.h"

#include "../Profiling/ProfilableClass.h"

// nkExport
#include <NilkinsExport/Exportable/Exportable.h>

// Standards
#include <string>

/// Class ------------------------------------

namespace nkGraphics
{
	class DLL_GRAPHICS_EXPORT Pass : public ProfilableClass, public nkExport::Exportable
	{
		friend class TargetOperations ;

		protected :
		
			// Attributs
			// La targetOperation mère
			TargetOperations* _parent ;

			// Le type de Pass en string pour les différencier
			PASS_TYPE _passType ;

			// Leur noms pour debug si besoin est
			std::string _name ;

		protected :

			// Functions
			// Constructor, destructor
			Pass () ;
			virtual ~Pass () ;
		
		public :

			// Getters
			TargetOperations* getParentTargetOperations () const ;
			PASS_TYPE getPassType () const ;
			const char* getName () const ;

			// Setter
			void setParentTargetOperations (TargetOperations* parent) ;
			void setName (const char* name) ;

			// Le rendu est nécessaire
			virtual void render () = 0 ;

			// L'export et import
			virtual void exportClassToTree (nkExport::Node* rootNode) override ;
			virtual void importClassFromTree (nkExport::Node* rootNode) override ;
	} ;
}