﻿//////////////////////////////////////////////
// ResourceSettingsChecker.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkGraphics
{
	struct MapRequestDescriptor ;
}

/// Includes ---------------------------------

// nkGraphics
#include "../Utilities/DxDefinesWrapper.h"

// Standards
#include <string_view>

/// Class ------------------------------------

namespace nkGraphics
{
	class ResourceSettingsChecker
	{
		private :

			// Constructeur, destructeur
			ResourceSettingsChecker () ;
			~ResourceSettingsChecker () ;

		public :

			// Check si les settings de la resources permettent sa création ou non
			static bool checkResourceCreationSettings (USAGE usageFlag, unsigned int bindFlags, unsigned int cpuFlags, unsigned int miscFlags, void* cpuData, const std::string_view& resourceName) ;

			// Check si les settings permettent un map ou non
			static bool checkResourceMapCapacity (const MapRequestDescriptor& mapRequest, USAGE usageFlag, unsigned int cpuFlags, bool texture, const std::string_view& resourceName) ;
			// Check si les settings nécessitent un map avec une copie de la resource ou non
			static bool resourceNeedsStagingMap (const MapRequestDescriptor& mapRequest, USAGE usageFlag, unsigned int cpuFlags, bool texture, const std::string_view& resourceName) ;
	} ;
}