﻿//////////////////////////////////////////////
// StringUtils.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkScripts
{
	enum class INTERPRETER ;
}

/// Includes ---------------------------------

// nkScripts
#include "../Dll/DllDefines.h"

// Standards
#include <string_view>
#include <vector>

/// Class ------------------------------------

namespace nkScripts
{
	class StringUtils final
	{
		private :

			// Constructeur, destructeur
			StringUtils () = delete ;
			~StringUtils () = delete ;

		public :

			// Splits namespace - type
			static std::vector<std::string> splitUserTypeName (const std::string_view& userTypeName) ;

			// Interpreter
			static std::string_view interpreterToString (INTERPRETER value) ;
			static INTERPRETER stringToInterpreter (const std::string_view& value) ;
	} ;
}